/*define var ch as char.
procedure proc0.
   define input parameter i as int.
   define input parameter j as int64.

   export string(i) + "bla" + string(ch).
end.

procedure proc1.
   define input parameter i as int.
   define input parameter j as int64.

   export string(i) + "bla" + string(ch).
end.

run proc0 (input 2, input 3).
run proc0 (input 4, input 5).
*/

on assign of book.isbn do:
   DISPLAY "Triggered session ASSIGN book.isbn hidden".
end.

on assign of book.isbn old oldisbn like book.isbn override do:
   DISPLAY "Triggered session ASSIGN book.isbn hidden".
end.


on assign of book.isbn old oldisbn2 as char /*no-undo*/ label "Label" init "---" format "x(2)" do:
   DISPLAY "Triggered session ASSIGN book.isbn hidden".
end.

on assign of book.isbn old oldisbn do:
   DISPLAY "Triggered session ASSIGN book.isbn =" book.isbn "Old =" oldisbn
           WITH NO-LABELS NO-BOX.

   on assign of book.publisher old oldpublisher override do:
      DISPLAY "Triggered session ASSIGN book.publisher =" book.publisher "Old =" oldpublisher
            "(oldisbn =" oldisbn ")"
           WITH NO-LABELS NO-BOX.
   end.
end.

on create of book do:
   DISPLAY "Triggered session CREATE book =" book.isbn
           WITH NO-LABELS NO-BOX.
end.

on delete of book do:
   DISPLAY "Triggered session DELETE book =" book.isbn
           WITH NO-LABELS NO-BOX.
end.

on find of book do:
   DISPLAY "Triggered session FIND book =" book.isbn
           WITH NO-LABELS NO-BOX.
end.

on write of book do:
   DISPLAY "Triggered session WRITE book hidden".
end.

on write of book old buffer oldb do:
   DISPLAY "Triggered session WRITE book hidden".
end.

on write of book new buffer newb old buffer oldb do:
   DISPLAY "Triggered session WRITE New =" newb.isbn "Old =" oldb.isbn
           WITH NO-LABELS NO-BOX.
end.

/* fire all triggers */

do transaction:
   create book.
   assign book.isbn = "aaa"
          book.book-title = "xxx".
   book.publisher = "ppppppp".
end.

find first book where book.book-title = "xxx".
delete book.


/*
Expected output:

Triggered session CREATE book =
Triggered schema CREATE of book ISBN:
Triggered schema REPLICATION-CREATE of book ISBN:
Triggered session ASSIGN book.isbn = aaa             Old =
Triggered schema ASSIGN book.isbn = aa Old =
Triggered session WRITE New = aaa             Old =
Triggered schema WRITE book old:                 new: aaa
Triggered schema REPLICATION-WRITE of book new: ISBN: aaa             old: ISBN:
Triggered schema FIND on book ISBN: aaa
Triggered session FIND book = aaa
Triggered session DELETE book = aaa
Triggered schema DELETE of book ISBN: aaa
Triggered schema REPLICATION-DELETE of book ISBN: aaa

--------------
function from procedure form schema trigger
procedure from schema trigger ?
anonymous trigger
function from procedure from trigger  -> aaa
procedure in schema trigger ?
*/
