on assign of book.book-title old oldbook no-undo format "x(3)" label "GotIt" do:
    define variable k as integer init 0.
    define variable u as integer init 0 no-undo.

    display "Trigger       oldbook        undo    no-undo" skip.
    display "before block:" oldbook + "" k + 0 u + 0 skip.

    do transaction:
        oldbook = "a".
        k = 1.
        u = 1.
        display "inside block:" oldbook + "" k + 0 u + 0 skip.
        undo, leave.
    end.

    display "after block: " oldbook + "" k + 0 u + 0 skip.

    oldbook = "1234567890".
    display oldbook with side-label.
end.

on assign of book.isbn old oldisbn do:
    define variable k as integer init 0.
    define variable u as integer init 0 no-undo.

    display "Trigger       oldisbn        undo    no-undo" skip.
    display "before block:" oldisbn + "" k + 0 u + 0 skip.

    do transaction:
        oldisbn = "a".
        k = 1.
        u = 1.
        display "inside block:" oldisbn + "" k + 0 u + 0 skip.
        undo, leave.
    end.

    display "after block: " oldisbn + "" k + 0 u + 0 skip.

    oldisbn = "1234567890".
    display oldisbn with side-label.
end.

do transaction:
    create book.
    book.isbn = "abc".
    book.book-title = "abc".
end.

find first book where isbn = "abc".
delete book.

/* expected output:
┌────────────────────────────────────────────┐
│Trigger       oldisbn        undo    no-undo│
│before block:          0          0         │
│inside block: a        1          1         │
│after block:           0          1         │
│ISBN: 1234567890                            │
└────────────────────────────────────────────┘
┌────────────────────────────────────────────┐
│Trigger       oldbook        undo    no-undo│
│before block:          0          0         │
│inside block: a        1          1         │
│after block:  a        0          1         │
│GotIt: 123                                  │
└────────────────────────────────────────────┘
*/

