define variable c1 as int no-undo.
define variable c2 as char.

function f1 returns logical (input fp1 as int, input fp2 as char):
define variable fv1 as int.
    define variable fv2 as char.
    fv1 = fp1.
    fv2 = fp2.
    return true.
end function.

procedure p1:
    define input parameter pp1 as int.
    define input parameter pp2 as char.

    define variable pv1 as int.
    define variable pv2 as char.
    assign pv1 = pp1
    pv2 = pp2.
    export "bla" + string(c1).
end.

/* session find triggers */
on find of book override
    display "Session FIND 1 book" book-title.

on find of book
    display "Session FIND 2 book" book-title.

/* session create triggers */
on create of book 
    display "Session CREATE 1 book" book-title.

on create of book override
    display "Session CREATE 2 book" book-title.

/* session delete triggers */
on delete of book override
    display "Session DELETE 1 book" book-title.

on delete of book
    display "Session DELETE 2 book" book-title.

/* session write triggers */
on write of book
    display "Session WRITE 1 book" book-title.

on write of book override
    display "Session WRITE 2 book" book-title.

on write of book old wob
    display "Session WRITE 3 book" wob.book-title.

on write of book old wob override
    display "Session WRITE 4 book" wob.book-title.

on write of book old buffer wob
    display "Session WRITE 5 book" wob.book-title.

on write of book old buffer wob override
    display "Session WRITE 6 book" wob.book-title.

on write of book new wnb
    display "Session WRITE 7 book" wnb.book-title.

on write of book new wnb override
    display "Session WRITE 8 book" wnb.book-title.

on write of book new buffer wnb
    display "Session WRITE 9 book" wnb.book-title.

on write of book new buffer wnb override
    display "Session WRITE 10 book" wnb.book-title.

on write of book new wnb old wob
    display "Session WRITE 11 book" wnb.book-title.

on write of book new wnb old wob override
    display "Session WRITE 12 book" wnb.book-title.

on write of book new buffer wnb old buffer wob
    display "Session WRITE 13 book" wnb.book-title.

on write of book new buffer wnb old buffer wob override
    display "Session WRITE 14 book" wnb.book-title.

/* session assign triggers */
on assign of book.book-title
    display "Session ASSIGN 1 book.book-title" book.book-title.

on assign of book.book-title override
    display "Session ASSIGN 2 book.book-title" book.book-title.

on assign of book.book-title old otv
    display "Session ASSIGN 3 book.book-title" book.book-title.

on assign of book.book-title old otv override
    display "Session ASSIGN 4 book.book-title" book.book-title.

on assign of book.book-title old value otv
    display "Session ASSIGN 5 book.book-title" book.book-title.

on assign of book.book-title old value otv override
    display "Session ASSIGN 6 book.book-title" book.book-title.

on assign of book.book-title old value otv as char
    display "Session ASSIGN 7 book.book-title" book.book-title.

/*on assign of book.book-title old value otv like book-title override
    display "Session ASSIGN 8 book.book-title" book.book-title.*/

/*on assign of book.book-title old value otv as char init "___"
    display "Session ASSIGN 7 book.book-title" book.book-title.*/

/*on assign of book.book-title old value otv like book.book-title format "x(10)" override
    display "Session ASSIGN 8 book.book-title" book.book-title.*/

on find of book revert.
on create of book revert.
on delete of book revert.
on write of book revert.
on assign of book.book-title revert.

display "All Ok!".
