ON FIND OF book OVERRIDE DO: MESSAGE "trigger 1" book.author. END.
ON FIND OF book MESSAGE "trigger 2" book.author.

ON CREATE OF book MESSAGE "book created:" book.book-title.
ON DELETE OF book MESSAGE "book deleted:" book.book-title.

FUNCTION f0 RETURNS LOGICAL () :
   DISABLE TRIGGERS FOR DUMP OF book.
   FIND FIRST book.
   RETURN YES.
END.

MESSAGE f0().

MESSAGE CAN-FIND(book).
FIND FIRST book.

ON FIND OF book REVERT.

FIND FIRST book.

DO TRANSACTION:
   CREATE book.
   ASSIGN book.book-title = "xxx".
END.

DO TRANSACTION:
   FIND FIRST book WHERE book-title EQ "xxx".
   DELETE book.
END.


/* expected output:
yes
no
Triggered schema FIND on book Progress Programming 2
trigger 2 0
Triggered schema FIND on book Progress Programming 2
book created:
Triggered schema FIND of customer
Triggered schema ASSIGN Old:  New: xxx
Triggered schema WRITE old:  new: xxx
Triggered schema FIND on book xxx
book deleted: xxx
*/
